#ifndef __CH56X_USB1DEV372_H__
#define __CH56X_USB1DEV372_H__

#ifdef __cplusplus
extern "C" {
#endif

#define  GD25Q_CMD_WRITEENABLE   0x06
#define  GD25Q_CMD_WRITEDISABLE  0x04
#define  GD25Q_CMD_READSTATUS1   0x05
#define  GD25Q_CMD_READSTATUS2   0x35
#define  GD25Q_CMD_READSTATUS3   0x15
#define  GD25Q_CMD_WRITESTATUS1  0x01
#define  GD25Q_CMD_WRITESTATUS2  0x31
#define  GD25Q_CMD_WRITESTATUS3  0x11
#define  GD25Q_CMD_READDATA      0x03
#define  GD25Q_CMD_PAGEPROGRAM   0x02
#define  GD25Q_CMD_SECTORERASE   0x20
#define  GD25Q_CMD_BLOCKERASE32K 0x52
#define  GD25Q_CMD_BLOCKERASE64K 0xD8
#define  GD25Q_CMD_CHIPERASE     0xC7
#define  GD25Q_CMD_READID        0x9F
#define  GD25Q_CMD_EN4B          0xB7
#define  GD25Q_CMD_READEXTREG    0xC8
#define  GD25Q_CMD_WRITEEXTREG   0xC5

/********************************* 引脚定义 ************************************
*    PB7  <===========>  SCS1
*    PA0  <===========>  SCK1
*    PA1  <===========>  MOSI1
*    PA2  <===========>  MISO1
*******************************************************************************/
#define  SPI1_CS_LOW()        R32_PB_CLR |= 1<<7
#define  SPI1_CS_HIGH()       R32_PB_OUT |= 1<<7

extern  void SPI1_MASTER_INIT ( void );
extern  void SPI1_Trans( UINT8 data );
extern  UINT8 SPI1_Recv( void );
extern  UINT32 SPIFlash_ReadID();
extern  void WriteEnable( void );
extern  void WriteDisable( void );
extern  UINT8 ReadStatus1();
extern  UINT8 ReadStatus2();
extern  UINT8 ReadStatus3();
extern  void WriteStatus1( UINT8 Status );
extern  void WriteStatus2( UINT8 Status );
extern  void WriteStatus3( UINT8 Status );
extern  void ReadSPINorData( UINT32 StarAddr, UINT16 Len, PUINT8 RcvBuffer );
extern  void WaitExternalFlashIfBusy( void );
extern  void PageProgram( UINT32 StarAddr, UINT16 Len, PUINT8 RcvBuffer );
extern  void SectorErase( UINT32 Dst_Addr );
extern  void Block32KErase( UINT32 Dst_Addr );
extern  void Block64KErase( UINT32 Dst_Addr );
extern  void ChipErase();
extern  UINT8 ReadExtendedRegister();

#ifdef __cplusplus
}
#endif
#endif		//__CH56X_USB1DEV372_H__
