#include <stdio.h>
#include <nds32_isr.h>
#include <nds32_intrinsic.h>
#include "CH568SFR.H"

#include "USBShare.H"


//------ 设备模式
// 设备描述符
const UINT8 MyDevDescr[18] = {
		//Device Descriptor
		0x12, 0x01, 0x00, 0x02, 0xEF, 0x02, 0x01, THIS_ENDP0_SIZE, 0x3C, 0x30,
		0x02, 0x00, 0x00, 0x01, 0x01, 0x02, 0x03, 0x01 };
// 配置描述符
const UINT8 MyCfgDescr[32] = {
        //Configuration Descriptor 1
		0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x05, 0xC0, 0xFA,
		//Interface Descriptor 0/0 Mass Storage, 2 Endpoints
		0x09, 0x04, 0x00, 0x00, 0x02, 0x08, 0x06, 0x50, 0x04,
		//Endpoint Descriptor 01 1 Out, Bulk, 512 bytes
		0x07, 0x05, 0x01, 0x02, 0x00, 0x02, 0x00,
		//Endpoint Descriptor 81 1 In, Bulk, 64 bytes
		0x07, 0x05, 0x81, 0x02, 0x00, 0x02, 0x00, };

// 语言描述符
const UINT8 MyLangDescr[4] = { 0x04, 0x03, 0x09, 0x04 };
// 厂家信息 "LAB-Z.COM"
const UINT8 MyManuInfo[0x14] = { 
        0x14, 0x03, 'L',  0x00, 'A',  0x00,  'B', 0x00, 
		'-' , 0x00, 'Z',  0x00, '.',  0x00,  'C', 0x00, 
		'O' , 0x00, 'M',  0x00};
		
// 产品信息 DUMT
const UINT8 MyProdInfo[0x0A] = {
		0x0A, 0x03, 'D', 0x00, 'U', 0x00, 'M', 0x00, 
		'T' , 0x00};
		
// 序列号
const UINT8 MySerial[0x0E] = { 
		0x0E, 0x03, '0', 0x00, '1', 0x00, '2', 0x00, 
		'3' , 0x00, '4', 0x00, '5', 0x00
};

// String 4
const UINT8 String4[24] = {
// TinyUSB MSC
		0x18, 0x03, 0x54, 0x00, 0x69, 0x00, 0x6E, 0x00, 0x79, 0x00, 0x55, 0x00,
		0x53, 0x00, 0x42, 0x00, 0x20, 0x00, 0x4D, 0x00, 0x53, 0x00, 0x43, 0x00 };

// String 5
const UINT8 String5[30] = {
		// TinyUSB Device
		0x1E, 0x03, 0x54, 0x00, 0x69, 0x00, 0x6E, 0x00, 0x79, 0x00, 0x55, 0x00,
		0x53, 0x00, 0x42, 0x00, 0x20, 0x00, 0x44, 0x00, 0x65, 0x00, 0x76, 0x00,
		0x69, 0x00, 0x63, 0x00, 0x65, 0x00 };

const UINT8 InquiryReply[36] = { 
        0x00, 0x80, 0x02, 0x02, 0x00, 0x00, 0x00, 0x00,
		'D',  'U',   'M',  'T', 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00 };
UINT8 InquirySts[13] = { 
        0x55, 0x53, 0x42, 0x53, 0x20, 0x56, 0x21, 0xAE, 0x00,
		0x00, 0x00, 0x00, 0x00 };

const UINT8 RDFMCAPReply[12] = //READ FORMAT CAPACITIES
		{ 0x00, 0x00, 0x00, 0x08, 
                (TOTAL_SECOTORS >> 24) & 0xFF, 
                (TOTAL_SECOTORS>> 16) & 0xFF, (
                TOTAL_SECOTORS >> 8) & 0xFF, 
                (TOTAL_SECOTORS>> 0) & 0xFF, 
                0x02, 
                (DISK_SECTOR_SIZE >> 16) & 0xFF,
                (DISK_SECTOR_SIZE >> 8) & 0xFF, 
                (DISK_SECTOR_SIZE >> 0) & 0xFF };
UINT8 RDFMCAPSts[13] = { 
                0x55, 0x53, 0x42, 0x53, 0x10, 0x90, 0xF1, 0xAE, 
                0xF0, 0x00, 0x00, 0x00, 0x00 };

const UINT8 RDCAPREPLY[8] = { 
                ((TOTAL_SECOTORS - 1) >> 24) & 0xFF,
		((TOTAL_SECOTORS - 1) >> 16) & 0xFF, 
                ((TOTAL_SECOTORS - 1) >> 8) & 0xFF,
		((TOTAL_SECOTORS - 1) >> 0) & 0xFF, 
                0x00, 0x00, 0x02, 0x00 };
                
UINT8 RDCAPSts[13] = { 
                0x55, 0x53, 0x42, 0x53, 0x10, 0x90, 0xF1, 0xAE, 
                0x00, 0x00, 0x00, 0x00, 0x00 };

const UINT8 MODESENE6REPLY[4] = { 0x03, 0x00, 0x00, 0x00 };

UINT8 MODESENE6Sts[13] = { 
                0x55, 0x53, 0x42, 0x53, 0x10, 0x90, 0xF1, 0xAE, 
                0xBC, 0x00, 0x00, 0x00, 0x00 };

UINT8 TESTUNITREADYREPLY[13] = { 
                0x55, 0x53, 0x42, 0x53, 0x00, 0x00, 0x00, 0x00,
		0x00, 0x00, 0x00, 0x00, 0x00 };

UINT8 READ10REPLY[13] = { 
                0x55, 0x53, 0x42, 0x53, 0x00, 0x00, 0x00, 0x00, 
                0x00, 0x00, 0x00, 0x00, 0x00 };

UINT8 WRITE10REPLY[13] = { 
                0x55, 0x53, 0x42, 0x53, 0x00, 0x00, 0x00, 0x00, 
                0x00, 0x00, 0x00, 0x00, 0x00 };

struct _TranHeader TranHeader;

