#ifndef __CH56X_USBSHARE_H__
#define __CH56X_USBSHARE_H__

#ifdef __cplusplus
extern "C" {
#endif

#define  GET_MAX_LUN 0xFE
#define  DISK_SECTOR_SIZE  512

// 256MB 硬盘的扇区数
#define  TOTAL_SECOTORS  (256*1024*1024/DISK_SECTOR_SIZE)

// 定义使用的 SPINOR芯片的大小
// 这里定义 32MB 的 SPI NOR
#define  MAXSPINORADDRESS  32*1024*1024
// 定义使用的 PSRAM 芯片的大小
// 这里定义 8MB 的 SPI NOR
#define  MAXSPSRAMADDRESS  8*1024*1024
// 定义使用的硬盘大小
// 这里定义 256MB
#define  MAXDISKADDRESS  256*1024*1024

#define THIS_ENDP0_SIZE         0x40
#define ENDP1_SIZE              0x200

extern const UINT8 MyDevDescr[18];
extern const UINT8 MyCfgDescr[32];
extern const UINT8 MyLangDescr[4];
extern const UINT8 MyManuInfo[0x14];
extern const UINT8 MyProdInfo[0x0A];
extern const UINT8 MySerial[0x0E];
extern const UINT8 String4[24];
extern const UINT8 String5[30];
extern const UINT8 InquiryReply[36];
extern UINT8 InquirySts[13];
extern const UINT8 RDFMCAPReply[12];
extern UINT8 RDFMCAPSts[13];
extern const UINT8 RDCAPREPLY[8];
extern UINT8 RDCAPSts[13];
extern const UINT8 MODESENE6REPLY[4];
extern UINT8 MODESENE6Sts[13];
extern UINT8 TESTUNITREADYREPLY[13];
extern UINT8 READ10REPLY[13];
extern UINT8 WRITE10REPLY[13];


struct _TranHeader {
    // Offset 0  
	UINT32 Flag; //Bit0: 0 - Busy
			     //      1 – Not Busy
			     //Bit1: 0 - ReadOnly Enable
			     //      1 – ReadOnly Disable
	// Offset 4
    UINT32 Monot;//单调递增
	// Offset 8
	UINT32 Size; //本次传输的全部长度（头文件和内容） 1-8MB
	// Offset 12
	UINT32 Counter; //本次传输为第 Counter 段。例如，要传输一个64MB文件，
			  //需要分割成8段，第一次传输的 Counter 为7，最后一个为0；
	// Offset 16
	UINT16 FilenameLength; //文件名长度
	// Offset 18
	UINT8  Filename[494];
};

extern struct _TranHeader TranHeader;

#ifdef __cplusplus
}
#endif

#endif		//__CH56X_USBSHARE_H__
