/*
 ============================================================================
 Name        : main_usb1dev372.c
 Author      : wch_cc
 Version     : V1.0.0
 Copyright   :
 Description :
 ============================================================================
 */

#include <stdio.h>
#include <nds32_isr.h>
#include <nds32_intrinsic.h>
#include "CH568SFR.H"

#include "MYdebug.H"

#include "USB0.h"
#include "USB1.h"
#include "USBShare.h"
#include "Ch56X_GPIO.h"

int main()
{
        Interrupt_init( (1<<INT_ID_USB1)|(1<<INT_ID_USB0) );     /* 系统总中断开启 */
        SysClkInit();           /* 初始化系统时钟 */
        mInitSTDIO_UR3();       /* 调试信息初始化 printf调用 */

        CH56x_GPIOInit(GPIOA,GPIO_Pin_4,GPIO_Mode_Out_PP_8mA); /*初始化 PA4 为GPO*/
        CH56x_GPIOSetBits(GPIOA,GPIO_Pin_4); /*设置为低*/

        SPI0_MASTER_INIT(); // 初始化 SPI0
        SPI1_MASTER_INIT(); // 初始化 SPI1
        
		TranHeader.Flag=0x01; // 设置为 Not Busy
		
        USB0DeviceInit();            /* USB1Device Init */
        USB1DeviceInit();            /* USB1Device Init */
        printf("USB1 Device Init!\n");

        while(1)
        {
                mDelaymS(5000);
        };

        return 0;
}




